package com.nisum.Employeeinfo.advice;

import com.nisum.Employeeinfo.errorcode.ApiError;
import com.nisum.Employeeinfo.errorcode.ApiErrorCode;
import com.nisum.Employeeinfo.exception.EmployeeNotFoundException;
import com.nisum.Employeeinfo.exception.ExceptionResponse;
import com.nisum.Employeeinfo.exception.InvalidEmployeeDataException;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.http.server.reactive.ServerHttpRequest;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.RestControllerAdvice;

@RestControllerAdvice
public class EmployeeServiceException {

    @ExceptionHandler(EmployeeNotFoundException.class)
    public ResponseEntity<Object> handleEmployeeNotFoundException(EmployeeNotFoundException ex, ServerHttpRequest serverHttpRequest){

        ApiError apiError= new ApiError(
                ex.getErrorCode(),
                ex.getMessage(),
                serverHttpRequest.getURI().getPath()
        );
        ExceptionResponse response=new ExceptionResponse(apiError);
        return new ResponseEntity<>(response, HttpStatus.NOT_FOUND);
    }

    @ExceptionHandler(InvalidEmployeeDataException.class)
    public ResponseEntity<Object> handleInvalidEmployeeData(InvalidEmployeeDataException ex, ServerHttpRequest serverHttpRequest){

        ApiError apiError= new ApiError(
                ex.getErrorCode(),
                ex.getMessage(),
                serverHttpRequest.getURI().getPath()
        );
        ExceptionResponse response=new ExceptionResponse(apiError);
        return new ResponseEntity<>(response, HttpStatus.BAD_REQUEST);
    }

    @ExceptionHandler(Exception.class)
    public ResponseEntity<Object> handleGeneralException(Exception ex, ServerHttpRequest serverHttpRequest){

        ApiError apiError= new ApiError(
                ApiErrorCode.GENERAL_ERROR.getString(),
                ex.getMessage(),
                serverHttpRequest.getURI().getPath()
        );
        ExceptionResponse response=new ExceptionResponse(apiError);
        return new ResponseEntity<>(response, HttpStatus.INTERNAL_SERVER_ERROR);
    }

}
